;------------------------------------------------------------------------------------
; Test - 
;-Description:
;------------------------------------------------------------------------------------
TestDMABusyFlagDMAEnableToggleFillText:
	dc.b	'DMA Busy Flag DMA Toggle Fill       '
TestDMABusyFlagDMAEnableToggleFillTextEnd:
TestDMABusyFlagDMAEnableToggleFillExpectedResult:
	dc.w $0200, $4E00, $0200, $4E00, $0200, $4E00, $0200, $4E00, $0000, $1234, $0000, $0000, $0000, $0000, $0000, $0000
	dc.w $0202, $4E02, $0202, $4E02, $0202, $4E02, $0200, $4E00, $0000, $1234, $1212, $1212, $0000, $0000, $0000, $0000
TestDMABusyFlagDMAEnableToggleFill:
	;Initialize the text result block
	move.w	#(TestDMABusyFlagDMAEnableToggleFillTextEnd-TestDMABusyFlagDMAEnableToggleFillText),D7
	move.w	#3,(A0)+ ;Set the number of display lines
	move.w	D7,(A0)+ ;Set the text length
	move.w	#$0040,D6 ;Set the data length
	move.w	D6,(A0)+
	lea		TestDMABusyFlagDMAEnableToggleFillText,A1
	sub.w	#1,D7
	TestDMABusyFlagDMAEnableToggleFillWriteText:
	move.b	(A1)+,(A0)+
	dbf	D7,TestDMABusyFlagDMAEnableToggleFillWriteText
	move.w	#1,(A0)+ ;Set the expected result data present flag
	lea		TestDMABusyFlagDMAEnableToggleFillExpectedResult,A1 ;Write the expected result data to the buffer
	sub.w	#1,D6
	TestDMABusyFlagDMAEnableToggleFillWriteExpectedResultData:
	move.b	(A1)+,(A0)+
	dbf	D6,TestDMABusyFlagDMAEnableToggleFillWriteExpectedResultData

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Clear data in VRAM at 0x8150
	move.l	#$41500002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Wait a few cycles, to ensure the FIFO is empty before we proceed.
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	;Do a DMA fill operation to VRAM address 0x8002 with the DMA enable bit disabled
	move.w #$0100,D1
	move.w #$8F01,$C00004
;	move.w #$8154,$C00004
	move.w #$9300, D2
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9400, D2
	lsr.l  #8,D1
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9780,$C00004
	move.l #$40040082,(A0)	;DMA fill at VRAM address 0x8004
	nop ;If we uncomment this block, we get corrupted write data at the start of the
	nop ;fill. If we don't have any wait cycles between the control port write and the
	nop ;data port write, the written data is usually correct, with the exception that
	nop ;the byte order of the first write is reversed. If we do insert wait states
	nop ;between the control port write and the data port write, without any wait states
	nop ;before the control port write, the fill starts with a fill data of 0x00, and at
	nop ;some point during the fill operation, usually 4 or 5 bytes in, the data port
	nop ;write then occurs, and the fill operation from then on picks up the correct fill
	nop ;data from that data port write. In other words, if we don't insert a wait state
	nop ;between when we set all our registers for a fill above, and when we actually
	nop ;perform the control port write to setup for the fill operation, the fill can
	nop ;inadvertantly trigger immediately when the control port write is made, without
	nop ;waiting for the data port write to occur. We have found from testing that at
	nop ;least 20 NOP cycles are required in order to get reliable results, when the
	nop ;control port write occurs as a long word write from RAM.
	nop
	nop
	nop
	nop
	nop
	move.l (A0),$C00004

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Enable DMA
	move.w #$8154,$C00004

	;Do a partial control port write to correct the code register and address register data
	move.w #$4002,$C00004

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	move.w #$1234,$C00000	;Start DMA fill with 0x1234

	;Wait a few cycles, to ensure the FIFO is empty before we proceed.
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Wait a long time to give the DMA operation sufficient time to complete
	move.w	#$7FFF,D6
	TestDMABusyFlagDMAEnableToggleFillDMAWaitLoop12:
	dbf	D6,TestDMABusyFlagDMAEnableToggleFillDMAWaitLoop12

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Disable DMA, and restore the increment data.
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop
	move.l	#$01520002,$C00004 ;Read from VRAM at 0x8152
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000-0xA000
	move.l	#$40000002,$C00004
	move.w #$1000,D7
	TestDMABusyFlagDMAEnableToggleFillClearVRAMLoop1:
	move.w	#$0000,$C00000
	dbf	D7,TestDMABusyFlagDMAEnableToggleFillClearVRAMLoop1

	;Test 2 - Same as above, except this time we have the DMA enable flag set when we do
	;the initial control port writes, and disable it afterwards. Since the DMA enable
	;flag just indicates whether the state of CD5 can be modified by a control port
	;write, this should trigger a DMA operation.
	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Clear data in VRAM at 0x8140
	move.l	#$41400002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Wait a few cycles, to ensure the FIFO is empty before we proceed.
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	;Do a DMA fill operation to VRAM address 0x8002 with the DMA enable bit enabled
	move.w #$0100,D1
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9300, D2
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9400, D2
	lsr.l  #8,D1
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9780,$C00004
	move.l #$40040082,(A0)	;DMA fill at VRAM address 0x8004
	nop ;If we uncomment this block, we get corrupted write data at the start of the
	nop ;fill. If we don't have any wait cycles between the control port write and the
	nop ;data port write, the written data is usually correct, with the exception that
	nop ;the byte order of the first write is reversed. If we do insert wait states
	nop ;between the control port write and the data port write, without any wait states
	nop ;before the control port write, the fill starts with a fill data of 0x00, and at
	nop ;some point during the fill operation, usually 4 or 5 bytes in, the data port
	nop ;write then occurs, and the fill operation from then on picks up the correct fill
	nop ;data from that data port write. In other words, if we don't insert a wait state
	nop ;between when we set all our registers for a fill above, and when we actually
	nop ;perform the control port write to setup for the fill operation, the fill can
	nop ;inadvertantly trigger immediately when the control port write is made, without
	nop ;waiting for the data port write to occur. We have found from testing that at
	nop ;least 20 NOP cycles are required in order to get reliable results, when the
	nop ;control port write occurs as a long word write from RAM.
	nop
	nop
	nop
	nop
	nop
	move.l (A0),$C00004

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Disable DMA
	move.w #$8144,$C00004

	;Do a partial control port write to correct the code register and address register data
	move.w #$4002,$C00004

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	move.w #$1234,$C00000	;Start DMA fill with 0x1234

	;Wait a few cycles, to ensure the FIFO is empty before we proceed.
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Wait a long time to give the DMA operation sufficient time to complete
	move.w	#$7FFF,D6
	TestDMABusyFlagDMAEnableToggleFillDMAWaitLoop22:
	dbf	D6,TestDMABusyFlagDMAEnableToggleFillDMAWaitLoop22

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Restore the increment data.
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop
	move.l	#$01420002,$C00004 ;Read from VRAM at 0x8142
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000-0xA000
	move.l	#$40000002,$C00004
	move.w #$1000,D7
	TestDMABusyFlagDMAEnableToggleFillClearVRAMLoop2:
	move.w	#$0000,$C00000
	dbf	D7,TestDMABusyFlagDMAEnableToggleFillClearVRAMLoop2

	rts
