;------------------------------------------------------------------------------------
; Test - 
;-Description:
; The purpose of this test is to verify the correct data is returned from the status
; register for the FIFO state bits and DMA busy flag during and around DMA transfer
; operation execution.
;------------------------------------------------------------------------------------
TestDMABusyFlagDMATransferDataBlock:
	dc.w $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF, $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF
	dc.w $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF, $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF
	dc.w $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF, $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF
	dc.w $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF, $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD, $EEFF
TestDMABusyFlagDMATransferText:
	dc.b	'DMA Busy Flag DMA Transfer          '
TestDMABusyFlagDMATransferTextEnd:
TestDMABusyFlagDMATransferExpectedResult:
	dc.w $0200, $4E00, $0200, $4E00, $0200, $4E00, $0200, $4E00, $0000, $0011, $2233, $4455, $6677, $8899, $AABB, $CCDD
TestDMABusyFlagDMATransfer:
	;Initialize the text result block
	move.w	#(TestDMABusyFlagDMATransferTextEnd-TestDMABusyFlagDMATransferText),D7
	move.w	#2,(A0)+ ;Set the number of display lines
	move.w	D7,(A0)+ ;Set the text length
	move.w	#$0020,D6 ;Set the data length
	move.w	D6,(A0)+
	lea		TestDMABusyFlagDMATransferText,A1
	sub.w	#1,D7
	TestDMABusyFlagDMATransferWriteText:
	move.b	(A1)+,(A0)+
	dbf	D7,TestDMABusyFlagDMATransferWriteText
	move.w	#1,(A0)+ ;Set the expected result data present flag
	lea		TestDMABusyFlagDMATransferExpectedResult,A1 ;Write the expected result data to the buffer
	sub.w	#1,D6
	TestDMABusyFlagDMATransferWriteExpectedResultData:
	move.b	(A1)+,(A0)+
	dbf	D6,TestDMABusyFlagDMATransferWriteExpectedResultData

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Wait a few cycles, to ensure the FIFO is empty before we proceed.
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Do a DMA transfer operation from the source data block to 0x8002
	move.l	#TestDMABusyFlagDMATransferDataBlock,D0
	move.w #$0040,D1
	move.w #$8154,$C00004
	move.w #$8F02,$C00004
	move.w #$9300, D2
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9400, D2
	lsr.l  #8,D1
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9500, D2
	lsr.l  #1,D0
	move.b D0,D2
	move.w D2,$C00004
	move.w #$9600, D2
	lsr.l  #8,D0
	move.b D0,D2
	move.w D2,$C00004
	move.w #$9700, D2
	lsr.l  #8,D0
	move.b D0,D2
	move.w D2,$C00004
	;We do the transfer to initiate the DMA operation using RAM here, otherwise we almost
	;always get a lockup on the real hardware.
	move.l #$40020082,(A0)	;DMA transfer to VRAM address 0x8002
	move.l (A0),$C00004

	;##NOTE## Hardware testing has shown that when a DMA transfer operation terminates, the FIFO
	;is full of pending writes. Construct a test which looks for this.

	;Wait a few cycles, to ensure the FIFO is empty before we proceed.
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Wait a long time to give the DMA operation sufficient time to complete
	move.w	#$7FFF,D6
	TestDMABusyFlagDMATransferDMAWaitLoop2:
	dbf	D6,TestDMABusyFlagDMATransferDMAWaitLoop2

	;Test status register
	move.w $C00004,D5
	and.w #$FF02,D5
	move.w	D5,(A0)+
	move.w $C00004,D5
	nop
	and.w #$FF02,D5
	move.w	D5,(A0)+

	;Disable DMA, and restore the increment data.
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000-0xA000
	move.l	#$40000002,$C00004
	move.w #$1000,D7
	TestDMABusyFlagDMATransferClearVRAMLoop:
	move.w	#$0000,$C00000
	dbf	D7,TestDMABusyFlagDMATransferClearVRAMLoop

	rts
