;------------------------------------------------------------------------------------
; Test - 
;-Description:
;------------------------------------------------------------------------------------
TestDMACopyLengthRegUpdateText:
	dc.b	'DMA Copy Length Reg Update          '
TestDMACopyLengthRegUpdateTextEnd:
TestDMACopyLengthRegUpdateExpectedResult:
	dc.w $89AB, $CDEF, $0023, $0000, $0123, $0067, $0000, $0000, $89AB, $CDEF, $0023, $0000, $89AB, $CDEF, $0000, $0000
TestDMACopyLengthRegUpdate:
	;Initialize the text result block
	move.w	#(TestDMACopyLengthRegUpdateTextEnd-TestDMACopyLengthRegUpdateText),D7
	move.w	#2,(A0)+ ;Set the number of display lines
	move.w	D7,(A0)+ ;Set the text length
	move.w	#$0020,D6 ;Set the data length
	move.w	D6,(A0)+
	lea		TestDMACopyLengthRegUpdateText,A1
	sub.w	#1,D7
	TestDMACopyLengthRegUpdateWriteText:
	move.b	(A1)+,(A0)+
	dbf	D7,TestDMACopyLengthRegUpdateWriteText
	move.w	#1,(A0)+ ;Set the expected result data present flag
	lea		TestDMACopyLengthRegUpdateExpectedResult,A1 ;Write the expected result data to the buffer
	sub.w	#1,D6
	TestDMACopyLengthRegUpdateWriteExpectedResultData:
	move.b	(A1)+,(A0)+
	dbf	D6,TestDMACopyLengthRegUpdateWriteExpectedResultData

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Load data in VRAM at 0x9000
	move.l	#$50000002,$C00004
	move.w	#$0180,D7
	lea		TestDMACopyLengthRegUpdateSampleData,A1
	TestDMACopyLengthRegUpdateVRAMLoop:
	move.w	(A1)+,$C00000
	dbf	D7,TestDMACopyLengthRegUpdateVRAMLoop

	;Do a DMA copy operation from 0x9000 to 0x8000 for 0x0201 bytes
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9301,$C00004
	move.w #$9402,$C00004
	move.w #$9500,$C00004
	move.w #$9690,$C00004
	move.w #$97C0,$C00004
	move.l #$000000C2,(A0)	;DMA copy to VRAM address 0x8000
	move.l (A0),$C00004
	TestDMACopyLengthRegUpdateDMAWaitLoop1:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMACopyLengthRegUpdateDMAWaitLoop1
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$01FC0002,$C00004 ;Read from VRAM at 0x81FC
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA copy operation from 0x9000 to 0x8000, only updating the lower DMA
	;transfer count register to 0x03.
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9303,$C00004
	move.w #$9500,$C00004
	move.w #$9690,$C00004
	move.w #$97C0,$C00004
	move.l #$000000C2,(A0)	;DMA copy to VRAM address 0x8000
	move.l (A0),$C00004
	TestDMACopyLengthRegUpdateDMAWaitLoop2:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMACopyLengthRegUpdateDMAWaitLoop2
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA copy operation from 0x9000 to 0x8000 for 0x0201 bytes
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9301,$C00004
	move.w #$9402,$C00004
	move.w #$9500,$C00004
	move.w #$9690,$C00004
	move.w #$97C0,$C00004
	move.l #$000000C2,(A0)	;DMA copy to VRAM address 0x8000
	move.l (A0),$C00004
	TestDMACopyLengthRegUpdateDMAWaitLoop3:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMACopyLengthRegUpdateDMAWaitLoop3
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$01FC0002,$C00004 ;Read from VRAM at 0x81FC
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA copy operation from 0x9000 to 0x8000, only updating the upper DMA
	;transfer count register to 0x02.
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9402,$C00004
	move.w #$9500,$C00004
	move.w #$9690,$C00004
	move.w #$97C0,$C00004
	move.l #$000000C2,(A0)	;DMA copy to VRAM address 0x8000
	move.l (A0),$C00004
	TestDMACopyLengthRegUpdateDMAWaitLoop4:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMACopyLengthRegUpdateDMAWaitLoop4
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$01FC0002,$C00004 ;Read from VRAM at 0x81FC
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	rts

TestDMACopyLengthRegUpdateSampleData:
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF

	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF

	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
	dc.w $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF, $0123, $4567, $89AB, $CDEF
