;------------------------------------------------------------------------------------
; Test - 
;-Description:
;------------------------------------------------------------------------------------
TestDMACopySourceRegUpdateText:
	dc.b	'DMA Copy Source Reg Update          '
TestDMACopySourceRegUpdateTextEnd:
TestDMACopySourceRegUpdateExpectedResult:
	dc.w $5555, $4444, $3333, $2222, $1111, $FFFF, $EEEE, $DDDD, $FFFF, $EEEE, $DDDD, $CCCC
TestDMACopySourceRegUpdate:
	;Initialize the text result block
	move.w	#(TestDMACopySourceRegUpdateTextEnd-TestDMACopySourceRegUpdateText),D7
	move.w	#2,(A0)+ ;Set the number of display lines
	move.w	D7,(A0)+ ;Set the text length
	move.w	#$0018,D6 ;Set the data length
	move.w	D6,(A0)+
	lea		TestDMACopySourceRegUpdateText,A1
	sub.w	#1,D7
	TestDMACopySourceRegUpdateWriteText:
	move.b	(A1)+,(A0)+
	dbf	D7,TestDMACopySourceRegUpdateWriteText
	move.w	#1,(A0)+ ;Set the expected result data present flag
	lea		TestDMACopySourceRegUpdateExpectedResult,A1 ;Write the expected result data to the buffer
	sub.w	#1,D6
	TestDMACopySourceRegUpdateWriteExpectedResultData:
	move.b	(A1)+,(A0)+
	dbf	D6,TestDMACopySourceRegUpdateWriteExpectedResultData

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA transfer from 0x1F4 in the source data block to VRAM address 0x9000 for 8 bytes
	move.l	#(VRAMTestDataBlockAligned+$1F4),D0
	move.w #$0004,D1
	move.w #$8154,$C00004
	move.w #$8F02,$C00004
	move.w #$9300, D2
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9400, D2
	lsr.l  #8,D1
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9500, D2
	lsr.l  #1,D0
	move.b D0,D2
	move.w D2,$C00004
	move.w #$9600, D2
	lsr.l  #8,D0
	move.b D0,D2
	move.w D2,$C00004
	move.w #$9700, D2
	lsr.l  #8,D0
	move.b D0,D2
	move.w D2,$C00004
	;We do the transfer to initiate the DMA operation using RAM here, otherwise we almost
	;always get a lockup on the real hardware.
	move.l #$40000082,(A0)	;DMA transfer to VRAM address 0x8000
	move.l (A0),$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA copy operation from 0x00FA to 0x8000 for 4 bytes
	move.l #$00FA,D0
	move.w #$0004,D2
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9300, D7
	move.w D2,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$9400, D7
	lsr.l  #8,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$9500, D7
	move.w D0,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$9600, D7
	lsr.l  #8,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$97C0,$C00004
	move.l #$000000C2,(A0)	;DMA copy to VRAM address 0x8000
	move.l (A0),$C00004
	TestDMACopySourceRegUpdateDMAWaitLoop1:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMACopySourceRegUpdateDMAWaitLoop1
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA transfer from 0x1F4 in the source data block to VRAM address 0x8000 for 8 bytes, not updating
	;the lower address byte.
	move.l	#(VRAMTestDataBlockAligned+$1F4),D0
	move.w #$0004,D1
	move.w #$8154,$C00004
	move.w #$8F02,$C00004
	move.w #$9300, D2
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9400, D2
	lsr.l  #8,D1
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9500, D2
	lsr.l  #1,D0
	move.b D0,D2
;	move.w D2,$C00004
	move.w #$9600, D2
	lsr.l  #8,D0
	move.b D0,D2
	move.w D2,$C00004
	move.w #$9700, D2
	lsr.l  #8,D0
	move.b D0,D2
	move.w D2,$C00004
	;We do the transfer to initiate the DMA operation using RAM here, otherwise we almost
	;always get a lockup on the real hardware.
	move.l #$40000082,(A0)	;DMA transfer to VRAM address 0x8000
	move.l (A0),$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA copy operation from 0x00FE to 0x8000 for 4 bytes
	move.l #$00FE,D0
	move.w #$0004,D2
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9300, D7
	move.w D2,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$9400, D7
	lsr.l  #8,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$9500, D7
	move.w D0,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$9600, D7
	lsr.l  #8,D6
	move.b D6,D7
	move.w D7,$C00004
	move.w #$97C0,$C00004
	move.l #$000000C2,(A0)	;DMA copy to VRAM address 0x8000
	move.l (A0),$C00004
	TestDMACopySourceRegUpdateDMAWaitLoop2:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMACopySourceRegUpdateDMAWaitLoop2
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA transfer from 0x1FC in the source data block to VRAM address 0x8000 for 8 bytes, not updating
	;the middle address byte.
	move.l	#(VRAMTestDataBlockAligned+$1FC),D0
	move.w #$0004,D1
	move.w #$8154,$C00004
	move.w #$8F02,$C00004
	move.w #$9300, D2
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9400, D2
	lsr.l  #8,D1
	move.b D1,D2
	move.w D2,$C00004
	move.w #$9500, D2
	lsr.l  #1,D0
	move.b D0,D2
	move.w D2,$C00004
	move.w #$9600, D2
	lsr.l  #8,D0
	move.b D0,D2
;	move.w D2,$C00004
	move.w #$9700, D2
	lsr.l  #8,D0
	move.b D0,D2
	move.w D2,$C00004
	;We do the transfer to initiate the DMA operation using RAM here, otherwise we almost
	;always get a lockup on the real hardware.
	move.l #$40000082,(A0)	;DMA transfer to VRAM address 0x8000
	move.l (A0),$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	rts
