;------------------------------------------------------------------------------------
; Test - 
;-Description:
;------------------------------------------------------------------------------------
TestDMAFillLengthRegUpdateText:
	dc.b	'DMA Fill Length Reg Update          '
TestDMAFillLengthRegUpdateTextEnd:
TestDMAFillLengthRegUpdateExpectedResult:
	dc.w $6868, $6868, $6868, $0000, $68AC, $6868, $0000, $0000, $6868, $6868, $6868, $0000, $6868, $6868, $0068, $0000
TestDMAFillLengthRegUpdate:
	;Initialize the text result block
	move.w	#(TestDMAFillLengthRegUpdateTextEnd-TestDMAFillLengthRegUpdateText),D7
	move.w	#2,(A0)+ ;Set the number of display lines
	move.w	D7,(A0)+ ;Set the text length
	move.w	#$0020,D6 ;Set the data length
	move.w	D6,(A0)+
	lea		TestDMAFillLengthRegUpdateText,A1
	sub.w	#1,D7
	TestDMAFillLengthRegUpdateWriteText:
	move.b	(A1)+,(A0)+
	dbf	D7,TestDMAFillLengthRegUpdateWriteText
	move.w	#1,(A0)+ ;Set the expected result data present flag
	lea		TestDMAFillLengthRegUpdateExpectedResult,A1 ;Write the expected result data to the buffer
	sub.w	#1,D6
	TestDMAFillLengthRegUpdateWriteExpectedResultData:
	move.b	(A1)+,(A0)+
	dbf	D6,TestDMAFillLengthRegUpdateWriteExpectedResultData

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA fill operation to VRAM address 0x8000 for 0x0201 bytes
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9301,$C00004
	move.w #$9402,$C00004
	move.w #$9500,$C00004	;Set the DMA source register to 0x0000, just in case it is used in some way.
	move.w #$9600,$C00004
	move.w #$9780,$C00004
	move.l #$40000082,(A0)	;DMA fill at VRAM address 0x8000
	nop ;If we uncomment this block, we get corrupted write data at the start of the
	nop ;fill. If we don't have any wait cycles between the control port write and the
	nop ;data port write, the written data is usually correct, with the exception that
	nop ;the byte order of the first write is reversed. If we do insert wait states
	nop ;between the control port write and the data port write, without any wait states
	nop ;before the control port write, the fill starts with a fill data of 0x00, and at
	nop ;some point during the fill operation, usually 4 or 5 bytes in, the data port
	nop ;write then occurs, and the fill operation from then on picks up the correct fill
	nop ;data from that data port write. In other words, if we don't insert a wait state
	nop ;between when we set all our registers for a fill above, and when we actually
	nop ;perform the control port write to setup for the fill operation, the fill can
	nop ;inadvertantly trigger immediately when the control port write is made, without
	nop ;waiting for the data port write to occur. We have found from testing that at
	nop ;least 20 NOP cycles are required in order to get reliable results, when the
	nop ;control port write occurs as a long word write from RAM.
	nop
	nop
	nop
	nop
	nop
	move.l (A0),$C00004
	move.w #$68AC,$C00000	;Start DMA fill with 0x68AC
	TestDMAFillLengthRegUpdateDMAWaitLoop1:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMAFillLengthRegUpdateDMAWaitLoop1
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$01FC0002,$C00004 ;Read from VRAM at 0x81FC
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA fill operation to VRAM address 0x8000, only updating the lower DMA
	;transfer count register to 0x03.
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9303,$C00004
	move.w #$9500,$C00004	;Set the DMA source register to 0x0000, just in case it is used in some way.
	move.w #$9600,$C00004
	move.w #$9780,$C00004
	move.l #$40000082,(A0)	;DMA fill at VRAM address 0x8000
	nop ;If we uncomment this block, we get corrupted write data at the start of the
	nop ;fill. If we don't have any wait cycles between the control port write and the
	nop ;data port write, the written data is usually correct, with the exception that
	nop ;the byte order of the first write is reversed. If we do insert wait states
	nop ;between the control port write and the data port write, without any wait states
	nop ;before the control port write, the fill starts with a fill data of 0x00, and at
	nop ;some point during the fill operation, usually 4 or 5 bytes in, the data port
	nop ;write then occurs, and the fill operation from then on picks up the correct fill
	nop ;data from that data port write. In other words, if we don't insert a wait state
	nop ;between when we set all our registers for a fill above, and when we actually
	nop ;perform the control port write to setup for the fill operation, the fill can
	nop ;inadvertantly trigger immediately when the control port write is made, without
	nop ;waiting for the data port write to occur. We have found from testing that at
	nop ;least 20 NOP cycles are required in order to get reliable results, when the
	nop ;control port write occurs as a long word write from RAM. Note that we've just
	nop ;increased the number of NOP cycles to 28, as we were sometimes still getting
	nop ;failures with 24 NOP instructions.
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	move.l (A0),$C00004
	move.w #$68AC,$C00000	;Start DMA fill with 0x68AC
	TestDMAFillLengthRegUpdateDMAWaitLoop2:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMAFillLengthRegUpdateDMAWaitLoop2
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$00000002,$C00004 ;Read from VRAM at 0x8000
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA fill operation to VRAM address 0x8000 for 0x0201 bytes
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9301,$C00004
	move.w #$9402,$C00004
	move.w #$9500,$C00004	;Set the DMA source register to 0x0000, just in case it is used in some way.
	move.w #$9600,$C00004
	move.w #$9780,$C00004
	move.l #$40000082,(A0)	;DMA fill at VRAM address 0x8000
	nop ;If we uncomment this block, we get corrupted write data at the start of the
	nop ;fill. If we don't have any wait cycles between the control port write and the
	nop ;data port write, the written data is usually correct, with the exception that
	nop ;the byte order of the first write is reversed. If we do insert wait states
	nop ;between the control port write and the data port write, without any wait states
	nop ;before the control port write, the fill starts with a fill data of 0x00, and at
	nop ;some point during the fill operation, usually 4 or 5 bytes in, the data port
	nop ;write then occurs, and the fill operation from then on picks up the correct fill
	nop ;data from that data port write. In other words, if we don't insert a wait state
	nop ;between when we set all our registers for a fill above, and when we actually
	nop ;perform the control port write to setup for the fill operation, the fill can
	nop ;inadvertantly trigger immediately when the control port write is made, without
	nop ;waiting for the data port write to occur. We have found from testing that at
	nop ;least 20 NOP cycles are required in order to get reliable results, when the
	nop ;control port write occurs as a long word write from RAM.
	nop
	nop
	nop
	nop
	nop
	move.l (A0),$C00004
	move.w #$68AC,$C00000	;Start DMA fill with 0x68AC
	TestDMAFillLengthRegUpdateDMAWaitLoop3:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMAFillLengthRegUpdateDMAWaitLoop3
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$01FC0002,$C00004 ;Read from VRAM at 0x81FC
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	;Do a DMA fill operation to VRAM address 0x8000, only updating the upper DMA
	;transfer count register to 0x02.
	move.w #$8F01,$C00004
	move.w #$8154,$C00004
	move.w #$9402,$C00004
	move.w #$9500,$C00004	;Set the DMA source register to 0x0000, just in case it is used in some way.
	move.w #$9600,$C00004
	move.w #$9780,$C00004
	move.l #$40000082,(A0)	;DMA fill at VRAM address 0x8000
	nop ;If we uncomment this block, we get corrupted write data at the start of the
	nop ;fill. If we don't have any wait cycles between the control port write and the
	nop ;data port write, the written data is usually correct, with the exception that
	nop ;the byte order of the first write is reversed. If we do insert wait states
	nop ;between the control port write and the data port write, without any wait states
	nop ;before the control port write, the fill starts with a fill data of 0x00, and at
	nop ;some point during the fill operation, usually 4 or 5 bytes in, the data port
	nop ;write then occurs, and the fill operation from then on picks up the correct fill
	nop ;data from that data port write. In other words, if we don't insert a wait state
	nop ;between when we set all our registers for a fill above, and when we actually
	nop ;perform the control port write to setup for the fill operation, the fill can
	nop ;inadvertantly trigger immediately when the control port write is made, without
	nop ;waiting for the data port write to occur. We have found from testing that at
	nop ;least 20 NOP cycles are required in order to get reliable results, when the
	nop ;control port write occurs as a long word write from RAM.
	nop
	nop
	nop
	nop
	nop
	move.l (A0),$C00004
	move.w #$68AC,$C00000	;Start DMA fill with 0x68AC
	TestDMAFillLengthRegUpdateDMAWaitLoop4:
	move.w $C00004,D5
	btst #1,D5
	bne TestDMAFillLengthRegUpdateDMAWaitLoop4
	move.w #$8144,$C00004
	move.w #$8F02,$C00004

	;Test target memory
	move.l	#$01FC0002,$C00004 ;Read from VRAM at 0x81FC
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	move.w	$C00000,(A0)+
	nop ;Wait for a few cycles after a read before modifying any VDP settings. On the
	nop ;real hardware, if a control port write occurs immediately after a data port
	nop ;read, the VDP can lock up. Most likely, this occurs due to the read target
	nop ;being modified to an invalid target before a read pre-cache is complete.
	nop
	nop
	nop
	nop
	nop
	nop

	;Clear data in VRAM at 0x8000
	move.l	#$40000002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	;Clear data in VRAM at 0x81FC
	move.l	#$41FC0002,$C00004
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000
	move.w	#$0000,$C00000

	rts
